org.apache.commons.imaging.formats.jpeg.exif

## Class ExifRewriter

- java.lang.Object
- - org.apache.commons.imaging.common.BinaryFileParser
  - - org.apache.commons.imaging.formats.jpeg.exif.ExifRewriter

-     public class ExifRewriter
      extends BinaryFileParser

  Interface for Exif write/update/remove functionality for Jpeg/JFIF images.

  See the source of the ExifMetadataUpdateExample class for example usage.

  See Also:
    org.apache.commons.imaging.examples.WriteExifMetadataExample

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ExifRewriter.ExifOverflowException`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExifRewriter()` Constructor.
    `ExifRewriter(ByteOrder byteOrder)` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `removeExifMetadata(byte[] src, OutputStream os)` Reads a Jpeg image, removes all EXIF metadata (by removing the APP1 segment), and writes the result to a stream.
    `void` | `removeExifMetadata(ByteSource byteSource, OutputStream os)` Reads a Jpeg image, removes all EXIF metadata (by removing the APP1 segment), and writes the result to a stream.
    `void` | `removeExifMetadata(File src, OutputStream os)` Reads a Jpeg image, removes all EXIF metadata (by removing the APP1 segment), and writes the result to a stream.
    `void` | `removeExifMetadata(InputStream src, OutputStream os)` Reads a Jpeg image, removes all EXIF metadata (by removing the APP1 segment), and writes the result to a stream.
    `void` | `updateExifMetadataLossless(byte[] src, OutputStream os, TiffOutputSet outputSet)` Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.
    `void` | `updateExifMetadataLossless(ByteSource byteSource, OutputStream os, TiffOutputSet outputSet)` Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.
    `void` | `updateExifMetadataLossless(File src, OutputStream os, TiffOutputSet outputSet)` Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.
    `void` | `updateExifMetadataLossless(InputStream src, OutputStream os, TiffOutputSet outputSet)` Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.
    `void` | `updateExifMetadataLossy(byte[] src, OutputStream os, TiffOutputSet outputSet)` Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.
    `void` | `updateExifMetadataLossy(ByteSource byteSource, OutputStream os, TiffOutputSet outputSet)` Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.
    `void` | `updateExifMetadataLossy(File src, OutputStream os, TiffOutputSet outputSet)` Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.
    `void` | `updateExifMetadataLossy(InputStream src, OutputStream os, TiffOutputSet outputSet)` Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

    - ### Methods inherited from class org.apache.commons.imaging.common.BinaryFileParser

      `debugNumber, debugNumber, getByteOrder, setByteOrder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ExifRewriter

          public ExifRewriter()

      Constructor. to guess whether a file contains an image based on its file extension.

    - #### ExifRewriter

          public ExifRewriter(ByteOrder byteOrder)

      Constructor.

      Parameters:
        `byteOrder` - byte order of EXIF segment.

  - ### Method Detail

    - #### removeExifMetadata

          public void removeExifMetadata(File src,
                                         OutputStream os)
                                  throws ImageReadException,
                                         IOException,
                                         ImageWriteException

      Reads a Jpeg image, removes all EXIF metadata (by removing the APP1 segment), and writes the result to a stream.

      Parameters:
        `src` - Image file.
        `os` - OutputStream to write the image to.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data
      See Also:
        `File`, `OutputStream`, `File`, `OutputStream`

    - #### removeExifMetadata

          public void removeExifMetadata(byte[] src,
                                         OutputStream os)
                                  throws ImageReadException,
                                         IOException,
                                         ImageWriteException

      Reads a Jpeg image, removes all EXIF metadata (by removing the APP1 segment), and writes the result to a stream.
      Parameters:
        `src` - Byte array containing Jpeg image data.
        `os` - OutputStream to write the image to.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### removeExifMetadata

          public void removeExifMetadata(InputStream src,
                                         OutputStream os)
                                  throws ImageReadException,
                                         IOException,
                                         ImageWriteException

      Reads a Jpeg image, removes all EXIF metadata (by removing the APP1 segment), and writes the result to a stream.
      Parameters:
        `src` - InputStream containing Jpeg image data.
        `os` - OutputStream to write the image to.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### removeExifMetadata

          public void removeExifMetadata(ByteSource byteSource,
                                         OutputStream os)
                                  throws ImageReadException,
                                         IOException,
                                         ImageWriteException

      Reads a Jpeg image, removes all EXIF metadata (by removing the APP1 segment), and writes the result to a stream.
      Parameters:
        `byteSource` - ByteSource containing Jpeg image data.
        `os` - OutputStream to write the image to.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### updateExifMetadataLossless

          public void updateExifMetadataLossless(File src,
                                                 OutputStream os,
                                                 TiffOutputSet outputSet)
                                          throws ImageReadException,
                                                 IOException,
                                                 ImageWriteException

      Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

      Note that this uses the "Lossless" approach - in order to preserve data embedded in the EXIF segment that it can't parse (such as Maker Notes), this algorithm avoids overwriting any part of the original segment that it couldn't parse. This can cause the EXIF segment to grow with each update, which is a serious issue, since all EXIF data must fit in a single APP1 segment of the Jpeg image.

      Parameters:
        `src` - Image file.
        `os` - OutputStream to write the image to.
        `outputSet` - TiffOutputSet containing the EXIF data to write.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### updateExifMetadataLossless

          public void updateExifMetadataLossless(byte[] src,
                                                 OutputStream os,
                                                 TiffOutputSet outputSet)
                                          throws ImageReadException,
                                                 IOException,
                                                 ImageWriteException

      Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

      Note that this uses the "Lossless" approach - in order to preserve data embedded in the EXIF segment that it can't parse (such as Maker Notes), this algorithm avoids overwriting any part of the original segment that it couldn't parse. This can cause the EXIF segment to grow with each update, which is a serious issue, since all EXIF data must fit in a single APP1 segment of the Jpeg image.

      Parameters:
        `src` - Byte array containing Jpeg image data.
        `os` - OutputStream to write the image to.
        `outputSet` - TiffOutputSet containing the EXIF data to write.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### updateExifMetadataLossless

          public void updateExifMetadataLossless(InputStream src,
                                                 OutputStream os,
                                                 TiffOutputSet outputSet)
                                          throws ImageReadException,
                                                 IOException,
                                                 ImageWriteException

      Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

      Note that this uses the "Lossless" approach - in order to preserve data embedded in the EXIF segment that it can't parse (such as Maker Notes), this algorithm avoids overwriting any part of the original segment that it couldn't parse. This can cause the EXIF segment to grow with each update, which is a serious issue, since all EXIF data must fit in a single APP1 segment of the Jpeg image.

      Parameters:
        `src` - InputStream containing Jpeg image data.
        `os` - OutputStream to write the image to.
        `outputSet` - TiffOutputSet containing the EXIF data to write.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### updateExifMetadataLossless

          public void updateExifMetadataLossless(ByteSource byteSource,
                                                 OutputStream os,
                                                 TiffOutputSet outputSet)
                                          throws ImageReadException,
                                                 IOException,
                                                 ImageWriteException

      Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

      Note that this uses the "Lossless" approach - in order to preserve data embedded in the EXIF segment that it can't parse (such as Maker Notes), this algorithm avoids overwriting any part of the original segment that it couldn't parse. This can cause the EXIF segment to grow with each update, which is a serious issue, since all EXIF data must fit in a single APP1 segment of the Jpeg image.

      Parameters:
        `byteSource` - ByteSource containing Jpeg image data.
        `os` - OutputStream to write the image to.
        `outputSet` - TiffOutputSet containing the EXIF data to write.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### updateExifMetadataLossy

          public void updateExifMetadataLossy(byte[] src,
                                              OutputStream os,
                                              TiffOutputSet outputSet)
                                       throws ImageReadException,
                                              IOException,
                                              ImageWriteException

      Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

      Note that this uses the "Lossy" approach - the algorithm overwrites the entire EXIF segment, ignoring the possibility that it may be discarding data it couldn't parse (such as Maker Notes).

      Parameters:
        `src` - Byte array containing Jpeg image data.
        `os` - OutputStream to write the image to.
        `outputSet` - TiffOutputSet containing the EXIF data to write.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### updateExifMetadataLossy

          public void updateExifMetadataLossy(InputStream src,
                                              OutputStream os,
                                              TiffOutputSet outputSet)
                                       throws ImageReadException,
                                              IOException,
                                              ImageWriteException

      Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

      Note that this uses the "Lossy" approach - the algorithm overwrites the entire EXIF segment, ignoring the possibility that it may be discarding data it couldn't parse (such as Maker Notes).

      Parameters:
        `src` - InputStream containing Jpeg image data.
        `os` - OutputStream to write the image to.
        `outputSet` - TiffOutputSet containing the EXIF data to write.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### updateExifMetadataLossy

          public void updateExifMetadataLossy(File src,
                                              OutputStream os,
                                              TiffOutputSet outputSet)
                                       throws ImageReadException,
                                              IOException,
                                              ImageWriteException

      Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

      Note that this uses the "Lossy" approach - the algorithm overwrites the entire EXIF segment, ignoring the possibility that it may be discarding data it couldn't parse (such as Maker Notes).

      Parameters:
        `src` - Image file.
        `os` - OutputStream to write the image to.
        `outputSet` - TiffOutputSet containing the EXIF data to write.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

    - #### updateExifMetadataLossy

          public void updateExifMetadataLossy(ByteSource byteSource,
                                              OutputStream os,
                                              TiffOutputSet outputSet)
                                       throws ImageReadException,
                                              IOException,
                                              ImageWriteException

      Reads a Jpeg image, replaces the EXIF metadata and writes the result to a stream.

      Note that this uses the "Lossy" approach - the algorithm overwrites the entire EXIF segment, ignoring the possibility that it may be discarding data it couldn't parse (such as Maker Notes).

      Parameters:
        `byteSource` - ByteSource containing Jpeg image data.
        `os` - OutputStream to write the image to.
        `outputSet` - TiffOutputSet containing the EXIF data to write.
      Throws:
        `ImageReadException` - if it fails to read the JFIF segments
        `IOException` - if it fails to read the image data
        `ImageWriteException` - if it fails to write the updated data

Copyright © 2007–2020 The Apache Software Foundation. All rights reserved.